<template>
  <form class="py-4" @submit.prevent="emitSubmit">
    <div class="mb-2">
      <label
        for="chapter_number"
        class="text-gray-700 block text-sm font-bold capitalize"
      >
        number
      </label>
      <input
        id="chapter_number"
        v-model="item.number"
        :class="[
          'mt-1 w-full px-3 py-2 border rounded text-gray-800',
          violations?.number ? 'border-red-500' : 'border-gray-300',
        ]"
        type="number"
        placeholder=""
      />
      <div
        v-if="violations?.number"
        class="bg-red-100 rounded py-4 px-4 my-2 text-red-700 text-sm"
      >
        {{ violations.number }}
      </div>
    </div>
    <div class="mb-2">
      <label
        for="chapter_date"
        class="text-gray-700 block text-sm font-bold capitalize"
      >
        date
      </label>
      <input
        id="chapter_date"
        v-model="item.date"
        :class="[
          'mt-1 w-full px-3 py-2 border rounded text-gray-800',
          violations?.date ? 'border-red-500' : 'border-gray-300',
        ]"
        type="date"
        placeholder=""
      />
      <div
        v-if="violations?.date"
        class="bg-red-100 rounded py-4 px-4 my-2 text-red-700 text-sm"
      >
        {{ violations.date }}
      </div>
    </div>
    <div class="mb-2">
      <label
        for="chapter_book"
        class="text-gray-700 block text-sm font-bold capitalize"
      >
        book
      </label>
      <input
        id="chapter_book"
        v-model="item.book"
        :class="[
          'mt-1 w-full px-3 py-2 border rounded text-gray-800',
          violations?.book ? 'border-red-500' : 'border-gray-300',
        ]"
        type="text"
        placeholder=""
      />
      <div
        v-if="violations?.book"
        class="bg-red-100 rounded py-4 px-4 my-2 text-red-700 text-sm"
      >
        {{ violations.book }}
      </div>
    </div>

    <button
      type="submit"
      class="px-6 py-2 bg-green-500 text-white font-medium rounded shadow-md hover:bg-green-600"
    >
      Submit
    </button>
  </form>
</template>

<script lang="ts" setup>
import { toRef, ref, type Ref } from "vue";
import { formatDateInput } from "@/utils/date";
import type { Chapter } from "@/types/chapter";
import type { SubmissionErrors } from "@/types/error";

const props = defineProps<{
  values?: Chapter;
  errors?: SubmissionErrors;
}>();

const emit = defineEmits<{
  (e: "submit", item: Chapter): void;
}>();

const violations = toRef(props, "errors");

let item: Ref<Chapter> = ref({});

if (props.values) {
  item.value = {
    ...props.values,
    publicationDate: formatDateInput(props.values.publicationDate),
  };
}

function emitSubmit() {
  emit("submit", item.value);
}
</script>
